import java.util.*;
import java.io.*;
public class FileModifier{
    public static void main(String[] args){
        /**
         * Implement a program that modifies a text file by replacing some characters
         * with others based on a modification percentage provided by the user.
         */
        String path = "FilePath";
        double percentage = modification();
        modifyFile(path, percentage);
    }
    private static double modification(){
        double percentage = 0.0;
        Scanner input = new Scanner(System.in);
        try{
            System.out.print("Modification percentage (0 - 100]: ");
            String line = input.nextLine();
            percentage = Double.parseDouble(line);
            if(percentage < 0 || percentage > 100){
                System.out.println("Out of range");
                percentage = modification();
            }
        }
        catch(NumberFormatException e){
            System.err.println("Out of range");
            percentage = modification();
        }
        input.close();
        return percentage;
    }
    private static void modifyFile(String path, double percentage){
        try{
            Scanner input = new Scanner(new File(path));
            PrintWriter output = new PrintWriter(new FileWriter("temp.txt"));
            while(input.hasNextLine()){
                String line = input.nextLine();
                String modifiedLine = modifyLine(line, percentage);
                output.println(modifiedLine);
            }
            input.close();
            output.close();
            File originalFile = new File(path);
            File tempFile = new File("temp.txt");
            if(originalFile.delete()){
                if(!tempFile.renameTo(originalFile)){
                    System.out.println("Renaming failed");
                }
            }
            else{
                System.out.println("Deleting failed");
            }
            System.out.println("File modified by "+percentage+"%");
        }
        catch(IOException e){
            System.err.println("Error");
        }
    }
    private static String modifyLine(String line, double percentage){
        char[] modifiedLine = new char[line.length()];
        for(int i = 0; i < line.length(); i++){
            char currentChar = line.charAt(i);
            if(Math.random() < percentage / 100.0){
                if(currentChar == 'M'){
                    modifiedLine[i] = 'N';
                }
                else{
                    modifiedLine[i] = currentChar;
                }
            }
            else{
                modifiedLine[i] = currentChar;
            }
        }
        return new String(modifiedLine);
    }
}